Attribute VB_Name = "sleepCode"
'global declarations
'savestate related variables
 Public level(0 To 4096) As Byte
 Public entireSave(0 To 140407) As Byte
'interface related variables
 Public stateOffset, windowWidth, windowHeight, listLeft, listTop, _
 editorLeft, editorTop, previewLeft, previewTop, prefix, _
 tileSelected As Byte, oldImg As Byte, hPosPrevious, vPosPrevious, _
 tempAddress, currentMap(0 To 11) As Byte, tilesLoaded, ROM As Byte, _
 currentSphere As Byte, Stage, doRefresh, tilesOK, _
 entireStage(0 To 1023) As Byte, errTiles

Sub Main()
  If Command$ <> "" Then MsgBox "SLEEP v" & App.Major & "." & App.Minor & "." & App.Revision & " does not handle command line switches, etc."
  stateOffset = 256
  windowWidth = 4
  windowHeight = 3
  If App.Revision = 0 Then
    frmMDI.Caption = "SLEEP v" & App.Major & "." & App.Minor
  Else
    frmMDI.Caption = "SLEEP v" & App.Major & "." & App.Minor & "." & App.Revision
  End If
  frmMDI.Show
End Sub

Function dropTile(Index)
  On Error GoTo errhandler
  frmLevel.mapTile(Index).Picture = frmList.Picture1.Picture
  For getvOffset = 0 To windowHeight
    If Index >= getvOffset * windowWidth Then voffset = getvOffset
  Next
  For vposa = 0 To windowWidth * windowHeight Step windowWidth
    For hposa = 0 To windowWidth
      If Index = vposa + hposa Then hoffset = hposa
    Next
   Next
  level(frmLevel.Horizontal.Value + hoffset + stateOffset * (frmLevel.Vertical.Value + 1 + voffset)) = tileSelected
errhandler:
  Exit Function
End Function

Function updateLevel(hPos, vPos)
  On Error GoTo errhandler
  GoTo normal
errhandler:
  Exit Function
normal:
 'get folder from filename
  tempAddress = frmMDI.CommonDialogT.filename & "%"
  If Right$(tempAddress, 1) <> "\" Then
    Do
      tempAddress = Left$(tempAddress, Len(tempAddress) - 1)
      If Right$(tempAddress, 1) = "\" Then Exit Do
    Loop
   'Debug.Print tempAddress
  End If
 
 'position difference variables
  hDifference = hPos - hPosPrevious
  yDifference = vPos - vPosPrevious
  vPosPrevious = vPos
  hPosPrevious = hPos
  stateOffset = 256
  
  If tilesLoaded = True Then
    If hDifference > 1 Or hDifference < -1 Or yDifference < -1 Or yDifference > 1 Or doRefresh = 1 Then
      doRefresh = 0
      currentTile = -1
      For vRefresh = 1 To 3
        For hRefresh = 0 To 3
          currentTile = currentTile + 1
          frmLevel.mapTile(currentTile).Picture = LoadPicture(tempAddress & prefix & Hex((level(hRefresh + (stateOffset * vRefresh + (vPos * stateOffset + hPos))))) & ".gif")
        Next
      Next
    End If
    If hDifference = -1 Then
      frmLevel.mapTile(3).Picture = frmLevel.mapTile.Item(2).Picture
      frmLevel.mapTile(7).Picture = frmLevel.mapTile.Item(6).Picture
      frmLevel.mapTile(11).Picture = frmLevel.mapTile.Item(10).Picture
      frmLevel.mapTile(2).Picture = frmLevel.mapTile.Item(1).Picture
      frmLevel.mapTile(6).Picture = frmLevel.mapTile.Item(5).Picture
      frmLevel.mapTile(10).Picture = frmLevel.mapTile.Item(9).Picture
      frmLevel.mapTile(1).Picture = frmLevel.mapTile.Item(0).Picture
      frmLevel.mapTile(5).Picture = frmLevel.mapTile.Item(4).Picture
      frmLevel.mapTile(9).Picture = frmLevel.mapTile.Item(8).Picture
      frmLevel.mapTile(0).Picture = LoadPicture(tempAddress & prefix & Hex(level(0 + (stateOffset * 1 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile(4).Picture = LoadPicture(tempAddress & prefix & Hex(level(0 + (stateOffset * 2 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile(8).Picture = LoadPicture(tempAddress & prefix & Hex(level(0 + (stateOffset * 3 + (vPos * stateOffset + hPos)))) & ".gif")
    End If
    If hDifference = 1 Then
      frmLevel.mapTile(0).Picture = frmLevel.mapTile.Item(1).Picture
      frmLevel.mapTile(4).Picture = frmLevel.mapTile.Item(5).Picture
      frmLevel.mapTile(8).Picture = frmLevel.mapTile.Item(9).Picture
      frmLevel.mapTile(1).Picture = frmLevel.mapTile.Item(2).Picture
      frmLevel.mapTile(5).Picture = frmLevel.mapTile.Item(6).Picture
      frmLevel.mapTile(9).Picture = frmLevel.mapTile.Item(10).Picture
      frmLevel.mapTile(2).Picture = frmLevel.mapTile.Item(3).Picture
      frmLevel.mapTile(6).Picture = frmLevel.mapTile.Item(7).Picture
      frmLevel.mapTile(10).Picture = frmLevel.mapTile.Item(11).Picture
      frmLevel.mapTile(3).Picture = LoadPicture(tempAddress & prefix & Hex(level(3 + (stateOffset * 1 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile(7).Picture = LoadPicture(tempAddress & prefix & Hex(level(3 + (stateOffset * 2 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile(11).Picture = LoadPicture(tempAddress & prefix & Hex(level(3 + (stateOffset * 3 + (vPos * stateOffset + hPos)))) & ".gif")
    End If
    If yDifference = -1 Then
      frmLevel.mapTile(11).Picture = frmLevel.mapTile.Item(7).Picture
      frmLevel.mapTile(10).Picture = frmLevel.mapTile.Item(6).Picture
      frmLevel.mapTile(9).Picture = frmLevel.mapTile.Item(5).Picture
      frmLevel.mapTile(8).Picture = frmLevel.mapTile.Item(4).Picture
      frmLevel.mapTile(7).Picture = frmLevel.mapTile.Item(3).Picture
      frmLevel.mapTile(6).Picture = frmLevel.mapTile.Item(2).Picture
      frmLevel.mapTile(5).Picture = frmLevel.mapTile.Item(1).Picture
      frmLevel.mapTile(4).Picture = frmLevel.mapTile.Item(0).Picture
      frmLevel.mapTile(0).Picture = LoadPicture(tempAddress & prefix & Hex(level(0 + (stateOffset * 1 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile(1).Picture = LoadPicture(tempAddress & prefix & Hex(level(1 + (stateOffset * 1 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile(2).Picture = LoadPicture(tempAddress & prefix & Hex(level(2 + (stateOffset * 1 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile(3).Picture = LoadPicture(tempAddress & prefix & Hex(level(3 + (stateOffset * 1 + (vPos * stateOffset + hPos)))) & ".gif")
    End If
    If yDifference = 1 Then
      frmLevel.mapTile.Item(0).Picture = frmLevel.mapTile.Item(4).Picture
      frmLevel.mapTile.Item(1).Picture = frmLevel.mapTile.Item(5).Picture
      frmLevel.mapTile.Item(2).Picture = frmLevel.mapTile.Item(6).Picture
      frmLevel.mapTile.Item(3).Picture = frmLevel.mapTile.Item(7).Picture
      frmLevel.mapTile.Item(4).Picture = frmLevel.mapTile.Item(8).Picture
      frmLevel.mapTile.Item(5).Picture = frmLevel.mapTile.Item(9).Picture
      frmLevel.mapTile.Item(6).Picture = frmLevel.mapTile.Item(10).Picture
      frmLevel.mapTile.Item(7).Picture = frmLevel.mapTile.Item(11).Picture
      frmLevel.mapTile.Item(8).Picture = LoadPicture(tempAddress & prefix & Hex(level(0 + (stateOffset * 3 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile.Item(9).Picture = LoadPicture(tempAddress & prefix & Hex(level(1 + (stateOffset * 3 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile.Item(10).Picture = LoadPicture(tempAddress & prefix & Hex(level(2 + (stateOffset * 3 + (vPos * stateOffset + hPos)))) & ".gif")
      frmLevel.mapTile.Item(11).Picture = LoadPicture(tempAddress & prefix & Hex(level(3 + (stateOffset * 3 + (vPos * stateOffset + hPos)))) & ".gif")
    End If
  End If
  frmLevel.Refresh
End Function

Function loadTiles(CommonDialogT)

  On Error GoTo errhandler
  CommonDialogT.cancelError = True
  CommonDialogT.ShowOpen
  
  Open CommonDialogT.filename For Input As #1
    Input #1, tempPrefix
  Close #1
  If tempPrefix = "null" Then
    prefix = ""
  Else
    prefix = tempPrefix
  End If
  
  frmList.Show
  frmLevel.Show
  frmList.Left = 60
  frmList.Top = 60
  frmLevel.Left = 120 + frmList.Width
  frmLevel.Top = 60
  
  tilesLoaded = True
  frmLevel.Horizontal.Enabled = True
  frmLevel.Vertical.Enabled = True
  
  updateList (frmList.vScroll.Value)
  doRefresh = 1
  
  updateLevel 0, 0
  
  
  frmLevel.Vertical.Value = 0
  frmLevel.Horizontal.Value = 0
  tileSelected = Index + frmList.vScroll.Value
  oldImg = Index
  tilesOK = 1
  frmMDI.Command1.Enabled = False
  frmMDI.Command2.Enabled = False
 
  frmList.imgSample.Picture = frmList.imgList(0).Picture
  frmList.Picture1.Picture = frmList.imgList(0).Picture
  
  Exit Function
errhandler:
  errTiles = 1
  Exit Function
End Function

Function loadState(CommonDialog)
  On Error GoTo errhandler
  Close #1
  Open CommonDialog.filename For Binary As #1
    Get #1, &HA478& + 1, level
    Get #1, &H0& + 1, entireSave
  Close #1
  'frmMDI.openTiles.Enabled = True
  'frmMDI.openState.Enabled = False
errhandler:
  Exit Function
End Function

Function updateList(vScroll)
  For redrawList = 0 To 4
    frmList.imgList(redrawList).Picture = LoadPicture(frmMDI.CommonDialogT.InitDir & prefix & Hex(vScroll + redrawList) & ".gif")
  Next
End Function

Function placeTiles(prefix, folder)
  On Error GoTo errhandler
  For i = 0 To 255
    hexnum = Hex(i)
    If Len(hexnum) = 1 Then
      hexnum = "0" & hexnum
    End If
  Next i
errhandler:
  Exit Function
End Function

Function closeSleep()
  Unload frmLevel
  Unload frmList
  Unload frmPreview
  Unload frmAbout
  Unload frmMDI
End Function
Function makeState(CommonDialog)
  On Error GoTo errhandler
  CommonDialog.cancelError = True
  Close #1
  Open CommonDialog.filename For Binary As #1
    Put #1, &H0& + 1, entireSave
    Put #1, &HA478& + 1, level
  Close #1
errhandler:
  Exit Function
End Function

